
Core - Feature # 34944

Status: Resolved Priority: Should have
Author: Roland Waldner Category: Fluid
Created: 2012-03-16 Assigned To:
Updated: 2015-01-18 Due date:
PHP Version:
Complexity:
Sprint Focus:
Subject: Paginate viewhelper should be possible to handle non-query-result objects 
Description

this threat is associated to the ticket:

http://lists.typo3.org/pipermail/typo3-project-typo3v4mvc/2012-March/011988.html

Related issues:
related to TYPO3.Fluid - Feature # 11740: Paginate viewhelper should be possi... Closed 2010-12-27

Associated revisions
Revision ec9899d6 - 2015-01-18 22:29 - Tom Ruether

[FEATURE] Paginate should handle non-query-result objects

Sometimes it is necessary to use an object storage or
an array instead of a query result.
Tested-by: Christian Kuhn <lolli@schwarzbu.ch>

History
#1 - 2012-03-17 19:30 - Roland Waldner

--- quote ---

Hello,

sometimes it is necessary to use an object storage or an array instead of an query result. If this is the case, it is not possible to use the default paginate
viewhelper anymore, cause it is requiering a Tx_Extbase_Persistence_QueryResultInterface.

I've copied the widget and changed it to work with array. This is my indexAction of PaginateController:
public function indexAction($currentPage = 1) {
        // set current page
        $this->currentPage = (integer)$currentPage;
        if ($this->currentPage < 1) {
            $this->currentPage = 1;
        } elseif ($this->currentPage > $this->numberOfPages) {
            $this->currentPage = $this->numberOfPages;
        }
$i = 0;
        $itemsPerPage = (integer)$this->configuration['itemsPerPage'];
        $modifiedObjects = array();
        $indexMin = $itemsPerPage * ($this->currentPage - 1);
        $indexMax = $itemsPerPage * $this->currentPage - 1;
foreach ($this->objects as $object) {
            if ($i >= $indexMin && $i <= $indexMax ) {
                $modifiedObjects[] = $object;
            }
            $i++;
        }
$this->view->assign('contentArguments', array(
            $this->widgetConfiguration['as'] => $modifiedObjects
        ));
        $this->view->assign('configuration', $this->configuration);
        $this->view->assign('pagination', $this->buildPagination());
    }

Of cause you would have to remove the requirement of Tx_Extbase_Persistence_QueryResultInterface in PaginateViewHelper (Line 76 and 71) and
PaginateController (Line 34) too.

This example is for arrays only, but if you make a check of the objecttype you can consolidate the support of queryResults (current) and arrays (this
code example).

And it is relatively less work.

--- /quote ---

#2 - 2012-09-11 09:11 - Ingo Pfennigstorf
- Category set to 964
- Status changed from New to Accepted
- Target version set to 6.1.0

#3 - 2012-09-21 09:48 - Ingo Pfennigstorf
- Target version changed from 6.1.0 to 1910

#4 - 2012-12-07 14:40 - Max Messing

            // Modified to let it work with non query result interfaces
            if(is_a($this->objects, 'Tx_Extbase_Persistence_QueryResultInterface')){
                $query = $this->objects->getQuery();
                $query->setLimit($itemsPerPage);
                if ($this->currentPage > 1) {
                    $query->setOffset((integer)($itemsPerPage * ($this->currentPage - 1)));
                }
                $modifiedObjects = $query->execute();
            }else{
                $offset = 0;
                if ($this->currentPage > 1) {
                    $offset = ((integer)($itemsPerPage * ($this->currentPage - 1)));
                }
                $modifiedObjects = array_slice($this->objects->toArray(), $offset, (integer)$this->configuration['itemsPerPage']);
            }

#5 - 2013-01-02 13:37 - Anja Leichsenring
- Project changed from Extbase MVC Framework to Fluid
- Category changed from 964 to Fluid: Widgets
- Target version deleted (1910)

#6 - 2013-11-19 14:44 - Mohamed Rebai

Is this feature going to be implemented or not ? I need to apply a pagination on a array!

#7 - 2013-11-26 12:07 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25687

#8 - 2013-11-26 13:55 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25687

#9 - 2013-11-27 11:41 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25687

#10 - 2014-09-12 10:33 - Alexander Opitz
- Project changed from Fluid to Core
- Category changed from Fluid: Widgets to Fluid

#11 - 2014-12-21 21:01 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/25687

#12 - 2014-12-21 21:29 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/25687

#13 - 2014-12-22 09:48 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/25687

#14 - 2014-12-22 12:21 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/25687

#15 - 2014-12-22 13:38 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/25687

#16 - 2014-12-22 14:19 - Gerrit Code Review

Patch set 11 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/25687

#17 - 2015-01-02 23:39 - Gerrit Code Review

Patch set 12 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/25687

#18 - 2015-01-18 16:21 - Gerrit Code Review

Patch set 13 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/25687

#19 - 2015-01-18 16:22 - Gerrit Code Review

Patch set 14 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/25687

#20 - 2015-01-18 17:00 - Gerrit Code Review

Patch set 15 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/25687

#21 - 2015-01-18 22:30 - Tom Ruether
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:ec9899d601dd5b318c62ba9c6653bf9543525821.
